﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace SinlgeLineText
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        float nextText = 0;
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            //Creates a new pdf document
            PdfDocument doc = new PdfDocument();

            //Add a page
            PdfPage page = doc.Pages.Add();

            //Create Pdf graphics for the page
            PdfGraphics g = page.Graphics;

            PdfBrush brush = PdfBrushes.Black;

            PdfFont boldFont = new PdfStandardFont(PdfFontFamily.TimesRoman, 12, PdfFontStyle.Bold);
            PdfFont regularFont = new PdfStandardFont(PdfFontFamily.TimesRoman, 12, PdfFontStyle.Regular);
            PdfFont italicFont = new PdfStandardFont(PdfFontFamily.TimesRoman, 12, PdfFontStyle.Italic);

          

            PdfLayoutResult result;

            result = AddString("Hello World ", page, 0, brush, boldFont);
            result = AddString("Hello World ", page, result.Bounds.Width, brush, regularFont);
            result = AddString("Hello World ", page, result.Bounds.Width, brush, italicFont);
           

            MemoryStream m = new MemoryStream();
            doc.Save(m);
            Save(m, "Sample.pdf");
        }

        private PdfLayoutResult AddString(string note, PdfPage newPage, float xPosition, PdfBrush brush, PdfFont font)
        {


            float SpacValue = 10.0f;

            nextText = nextText + (xPosition + SpacValue);


            //Rendering Text

            PdfTextElement richTextElement = new PdfTextElement(note, font, brush);

            //Drawing String

            PdfLayoutResult result = richTextElement.Draw(newPage, new RectangleF(nextText, 0, 0, 0));

            return result;

        }

        async void Save(Stream stream, string filename)
        {

            stream.Position = 0;

            FileSavePicker savePicker = new FileSavePicker();
            savePicker.DefaultFileExtension = ".pdf";
            savePicker.SuggestedFileName = "Sample";
            savePicker.FileTypeChoices.Add("Adobe PDF Document", new List<string>() { ".pdf" });
            StorageFile stFile = await savePicker.PickSaveFileAsync();
            if (stFile != null)
            {
                Windows.Storage.Streams.IRandomAccessStream fileStream = await stFile.OpenAsync(FileAccessMode.ReadWrite);
                Stream st = fileStream.AsStreamForWrite();
                st.Write((stream as MemoryStream).ToArray(), 0, (int)stream.Length);
                st.Flush();
                st.Dispose();
                fileStream.Dispose();
            }

            MessageDialog msgDialog = new MessageDialog("Do you want to view the Document?", "File has been created successfully.");
            UICommand yesCmd = new UICommand("Yes");
            msgDialog.Commands.Add(yesCmd);
            UICommand noCmd = new UICommand("No");
            msgDialog.Commands.Add(noCmd);
            IUICommand cmd = await msgDialog.ShowAsync();
            if (cmd == yesCmd)
            {
                // Launch the retrieved file
                bool success = await Windows.System.Launcher.LaunchFileAsync(stFile);
            }
        }
    }
}
